unit DynamicDsl_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, DBClient;

type
  TForm23 = class(TForm)
    Button2: TButton;
    Memo1: TMemo;
    Button1: TButton;
    ClientDataSet1: TClientDataSet;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ClientDataSet1CustNo: TFloatField;
    ClientDataSet1Company: TStringField;
    ClientDataSet1Addr1: TStringField;
    ClientDataSet1Addr2: TStringField;
    ClientDataSet1City: TStringField;
    ClientDataSet1State: TStringField;
    ClientDataSet1Zip: TStringField;
    ClientDataSet1Country: TStringField;
    ClientDataSet1Phone: TStringField;
    ClientDataSet1FAX: TStringField;
    ClientDataSet1TaxRate: TFloatField;
    ClientDataSet1Contact: TStringField;
    ClientDataSet1LastInvoiceDate: TDateTimeField;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form23: TForm23;

implementation

{$R *.dfm}

uses
  DynamicDslVariant, DateUtils, VarUtils;

type
  TMyDate = class (TDynamicClass)
  private
    fDate: TDateTime;
  public
    constructor Create;
    function DoProcedure(const V: TVarData; const Name: string;
      const Arguments: TVarDataArray): Boolean; override;
    function AsString: string; override;
  end;

  TMyValue = class (TDynamicClass)
  private
    fValue: Integer;
  public
    function DoProcedure(const V: TVarData; const Name: string;
      const Arguments: TVarDataArray): Boolean; override;
    function AsString: string; override;
  end;

  TMyDataSet = class (TDynamicClass)
  private
    fValue: TDataSet;
  public
    constructor Create (fDataSet: TDataSet);
    function DoFunction(var Dest: TVarData; const V: TVarData;
      const Name: string; const Arguments: TVarDataArray): Boolean; override;
    function DoProcedure(const V: TVarData; const Name: string;
      const Arguments: TVarDataArray): Boolean; override;
  end;

  TCDSHelper = class helper for TClientDataSet
  public
    function Read: variant;
  end;


procedure TForm23.Button1Click(Sender: TObject);
begin
  with TMyValue.Create do
  begin
    .OneMillion;
    Memo1.Lines.Add ();
  end;
end;

procedure TForm23.Button2Click(Sender: TObject);
var
  md: TMyDate;
  s: string;
begin
  Memo1.Lines.Clear;
//  s := v;
//  ShowMessage (s);

  md := TMyDate.Create;

//  if md.v.DoThat ('foo') then
//    showMessage ('there');

  md..NextMonday;
  md..am7;
  s := md.&do;
  Memo1.Lines.Add (s);

  md.&do.dec24;
  md.&do.pm5;
  Memo1.Lines.Add (md.AsString);
end;

procedure TForm23.Button3Click(Sender: TObject);
var
  mds: TMyDataSet;
  s: string;
begin
  mds := TMyDataSet.Create (ClientDataSet1);
  s := mds..Company();
  // s := mds..Company; // error: property not defined
  Memo1.Lines.Add (s);
  mds..Company;
end;

procedure TForm23.Button4Click(Sender: TObject);
var
  myrecord: variant;
begin
  myrecord := TMyDataSet.Create(ClientDataSet1).v;
  Memo1.Lines.Add (myrecord.Company());
end;

procedure TForm23.Button5Click(Sender: TObject);
var
  s: string;
begin
  s := ClientDataSet1.Read.Country();
  Memo1.Lines.Add (s);
end;

procedure TForm23.FormCreate(Sender: TObject);
begin
  ClientDataSet1.Open;
end;

{ TMyDate }

function TMyDate.AsString: string;
begin
  Result := DateTimeToStr (fDate);
end;

constructor TMyDate.Create;
begin
  inherited Create;
  fDate := Now;
end;

function TMyDate.DoProcedure(const V: TVarData; const Name: string;
  const Arguments: TVarDataArray): Boolean;
var
  tmp: string;
  value: Integer;
  tmpDate: TDateTime;
  month: Integer;
  day: Integer;
begin
  Result := False;

  if Pos ('AM', Name) > 0 then
  begin
    // parse and process...
    tmp := StringReplace (Name, 'AM', '', []);
    value := StrToIntDef (tmp, 0);
    fDate := RecodeTime (fDate, value, 0, 0, 0);
    Result := True;
  end;

  if Pos ('PM', Name) > 0 then
  begin
    // parse and process...
    tmp := StringReplace (Name, 'PM', '', []);
    value := StrToIntDef (tmp, 0);
    (GetDynamicObject(V) as TMyDate).fDate :=
      RecodeTime ((GetDynamicObject(V) as TMyDate).fDate, value + 12, 0, 0, 0);
    Result := True;
  end;

  if Pos ('NEXT', Name) > 0 then
  begin
    // parse and process...
    tmp := StringReplace (Name, 'NEXT', '', []);

    if tmp = 'MONDAY' then
    begin
      tmpDate := Now;
      value := DayOfWeek(tmpDate);
      tmpDate := tmpDate + 7 - value + 2; // monday as 2nd day of the week
      (GetDynamicObject(V) as TMyDate).fDate :=
        DateOf (tmpDate) + TimeOf ((GetDynamicObject(V) as TMyDate).fDate);
    end;
    Result := True;
  end;

  if Pos ('DEC', Name) > 0 then
  begin
    month := 12;
    // parse and process...
    tmp := StringReplace (Name, 'DEC', '', []);
    day := StrToIntDef (tmp, 0);
    (GetDynamicObject(V) as TMyDate).fDate :=
      RecodeDate ((GetDynamicObject(V) as TMyDate).fDate, YearOf (now), month, day);
    Result := True;
  end;
end;

{ TMyValue }

function TMyValue.AsString: string;
begin
  Result := IntToStr (fValue);
end;

function TMyValue.DoProcedure(const V: TVarData; const Name: string;
  const Arguments: TVarDataArray): Boolean;
begin
  Result := False;

  if SameStr ('ONEMILLION', Name) then
  begin
    // (GetDynamicObject(V) as TMyValue).fvalue := 1000000;
    fvalue := 1000000;
    Result := True;
  end;

  if SameStr ('ONETHOUSAND', Name) then
  begin
    fvalue := 1000;
    Result := True;
  end;

end;

{ TMyDataSet }

constructor TMyDataSet.Create(fDataSet: TDataSet);
begin
  inherited Create;
  fValue := fDataSet;
end;

function TMyDataSet.DoFunction(var Dest: TVarData; const V: TVarData;
  const Name: string; const Arguments: TVarDataArray): Boolean;
begin
  Result := True;
  // VariantClear(Dest);
  Variant(Dest) := fValue.FieldByName(Name).Value;
end;

function TMyDataSet.DoProcedure(const V: TVarData; const Name: string;
  const Arguments: TVarDataArray): Boolean;
begin
  Result := True;
  ShowMessage ('Procedure ' + Name + ': ' + fValue.FieldByName(Name).AsString);
end;

{ TCDSHelper }

function TCDSHelper.Read: variant;
begin
  Result := TMyDataSet.Create(self).&Do;
end;

end.
